/*
 * PM - 2017
 * lab0.c
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <stdlib.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

#define AREF 5
#define ADC_INIT_CHANNEL 0
#define PA4 4
#define PA3 3
#define PRAG_CRITIC_UMI 700
#define PRAG_MEDIU_UMI 350
#define PRAG_LUMINA_SLABA 1

void pump(void);

void pornestePompa(void)
{	
	PORTD |=  (1 << PD7);
}

void pornestePompa(void)
{

	PORTD &= ~(1 << PD7);
}

void ADC_init(void)
{
#ifndef ADC_USE_IRQ
    // enable ADC with:
    // * reference AVCC with external capacitor at AREF pin
    // * without left adjust of conversion result
    // * no auto-trigger
    // * no interrupt
    // * prescaler at 32
    ADMUX = (1 << REFS0);
    ADCSRA = (1 << ADEN) | (5 << ADPS0);
#else
    // enable ADC with interrupt, the rest of the settings like in TODO 2
    ADMUX = (1 << REFS0) | (1 << ADC_INIT_CHANNEL);
    ADCSRA = (1 << ADEN) | (1 << ADIE) | (5 << ADPS0);

#endif
}

/*
    Returns the result of an ADC conversion. 
    Starts a conversion and waits for the result when not using interrupts.
*/
int ADC_get(uint8_t channel)
{
#ifndef ADC_USE_IRQ
    // start ADC conversion on "channel"
    // wait for completion
    // return the result
    ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

    ADCSRA |= (1 << ADSC);
    while(ADCSRA & (1 << ADSC));

    return ADC;
#else
    return ADC_value[channel];
#endif

    (void)channel;
    return 0;
}

/*
    Converts a value given by the ADC to volts.
*/
double ADC_voltage(int raw)
{
    (void)raw;
    return raw * AREF / 1024.;
}

int main(void) {
	DDRD |= (1 << PD4) | (1 << PD7);
    DDRB |= (1 << PB3);
	ADC_init();
	int lumina, umiditate;
	while(1) {
		lumina = ADC_get(PA4); //intensitate lumina
		umiditate = ADC_get(PA3); //umiditatea
		
		if (umiditate > PRAG_CRITIC_UMI) {
			//Am umiditate putina, deci il aprind orice ar fi
			pornestePompa();
		}
		
		else if (umiditate > PRAG_MEDIU_UMI && lumina < PRAG_LUMINA_SLABA) {	
			//Am cevA multa umiditate, deci astept sa nu mai fie lumina
			pornestePompa();
		} else
			oprestePompa();

	}

	return 0;
}
